#include "structs.h"

void ScreenMode(int mode)
{
	asm {
			mov ax,mode
			int 0x10
	}
}

void setpal(uchar *pal)
{
	asm {
			mov ax,	0x1012
			mov bx,	0
			mov cx,	256
			les dx,	pal

			int 0x10
   };
}

void Detect_Mouse_Driver()
{
	asm {
		mov ax, 0x0000   // Detect driver ( I never bother to check !!)
		int 0x33
		mov ax, 0x0002   // Hide damn ting
		int 0x33

	}
}

void Do_Mouse_Interrupt()
{
	asm {
		mov 	ax,0x03
		int 	0x33
	}

}

void Load_PCX_data(FILE *fp,uchar huge *where,int xscan,int yscan)
{
	long int xcount,ycount,i;
	uchar buf,tbuf;
	for(ycount=0;ycount<yscan;ycount++)
	{
		xcount=0;
		while(xscan>xcount)
		{
			buf=fgetc(fp);
			if (buf>=192)
			{
				tbuf=buf-192;
				xcount+=tbuf;
				buf=fgetc(fp);
				for(i=0;i<tbuf;i++,where++)
				{
					*where=buf;   // this line doesn't work on a 586!!
				}
			}
			else
			{
				xcount++;
				*where=buf;
				where++;
			}
		}
	}
}

struct Picture_Type *Setup_PT(long Buffsize,int flags)
{
	uchar huge *where;
	struct Picture_Type *pic=NULL;
	where=farcalloc(Buffsize,1);

	if(where)
	{
		pic=malloc(sizeof(struct Picture_Type));
		if(pic)
		{
			pic->Data=where;
			if(flags & 1)
			{
				pic->Palette=malloc(768);
				if(pic->Palette)
				{
					return(pic);
				}
				free(pic->Palette);
			}
			else return(pic);
			free(pic);
		}
		else printf("malloc(Picture_Type)\n");
		farfree(where); // pic failed
	}
	else printf("farcalloc() failed to allocate %ld Bytes\n",Buffsize);
	return(NULL);
}

struct Picture_Type *Load_Thing(char name[],long size, int number_of_frames)
{
	int k,j,xscan,yscan;
	uchar huge *temp;
	FILE *fp;
	struct Picture_Type *pic=NULL;

	pic=Setup_PT((long)(((long)(number_of_frames))*((long)(size))),0);

	if(pic)
	{
		for(k=1;k<number_of_frames+1;k++)
		{
			name[10]=(k/10)+48;
			name[11]=(k%10)+48;
			temp=(pic->Data)+((((k-1)))*(size));
			fp=fopen(name,"rb");
			if(fp)
			{
				for(j=0;j<4;j++) fgetc(fp);	// should check PCX
				for(j=0;j<4;j++) fgetc(fp); // dummies
				xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
				pic->Width=xscan;
				pic->Height=yscan;

				printf("%d:%d",xscan,yscan);
				fseek(fp,128,SEEK_SET);
				Load_PCX_data(fp,temp,xscan,yscan);

				fclose(fp);
			}
			else
			{
				printf("Error: %s\n",name);
				getch();
			}
		}
	}
	else printf("Error Load_Men() (Setup_PT) !!\n");
	return(pic);
}


struct Picture_Type *Load_PCX(char *name,int flags)
{
	FILE *fp;
	int j,i;
	uchar huge *where;
	uchar *pal;
	int yscan=640,xscan=200;
	struct Picture_Type *pic=NULL;
	fp=fopen(name,"rb");

	if(fp)
	{
		for(j=0;j<4;j++) fgetc(fp);	// should check PCX
		for(j=0;j<4;j++) fgetc(fp); // dummies
		xscan=fgetc(fp)+(fgetc(fp)<<8)+1;
		yscan=fgetc(fp)+(fgetc(fp)<<8)+1;
		pic=Setup_PT((long)((long)(xscan)*(long)(yscan)),flags);
		if(pic) {
			where=pic->Data;

			pic->Width=xscan;
			pic->Height=yscan;
			fseek(fp,128,SEEK_SET);
			Load_PCX_data(fp,where,xscan,yscan);
			pic->Palette=NULL;
			if(flags & LP_LOAD_PALETTE) {
				printf("loading palette\n");
				pal=pic->Palette;
				fseek(fp,-768,SEEK_END);
				for(i=0;i<768;i++) *(pal++)=(fgetc(fp) >> 2);
				if(flags & LP_SET_PALETTE) setpal(pal);

			}
		}
		else{
			printf("Error: Memory -- Setup_PT\n");
			getch();
		}
		fclose(fp);
	}
	else {
		printf("\n\tCouldn't open file %s\n",name);
		getch();
	}

	return(pic);
}

void LoadPaletteScreen(char *name)
{
	FILE *fp;
	int i;
	uchar pal[768];
	fp=fopen(name,"rb");
	if(fp)
	{
		fseek(fp,-768,SEEK_END);
		for(i=0;i<768;i++) pal[i]=(fgetc(fp) >> 2);
		setpal(pal);
		fclose(fp);
	}else printf("Can't open file to load palette from\n");
}

void FreePic(struct Picture_Type *pic)
{
	if(pic!=NULL)
	{
		if (pic->Palette!=NULL) free(pic->Palette);
		if (pic->Data!=NULL) free(pic->Data);
		if (pic!=NULL) free(pic);
	}
	else printf("Already freed\n");
}

void ClearScreen(void)
{
	asm {
		push	ds
		mov		cx,0xA000
		mov		ds,cx
		mov		bx,0
		mov		cx,SCR_BLK
		mov		dl,0
	}
	nxtdot:
	asm {
		mov     ds:[bx],dl
		inc 	bx
		loop 	nxtdot
		pop		ds
	}
}

void WaitRetrace(void)
{
	asm {
			mov		dx,0x03DA
	}
	waitsomemore:
	asm {
			in		al,dx
			test	al,0x08
			jnz		waitsomemore
	}
}

/* The magic matrix, scaling translating rotating all in one go !!!*/

void Init_Matrix(float xangle, float yangle, float zangle,
					float mat[4][4])
{
	float sx,sy,sz,cx,cy,cz;

	sx = sin(xangle); //   ===0 !!! Gone !
	sy = sin(yangle); //   === 0 !!! Gone !
	sz = sin(zangle);

	cx = cos(xangle); //   ===1 Gone
	cy = cos(yangle); //      =1 Gone !!!
	cz = cos(zangle);

	mat[0][0] = ((cz));// - (sz * 0 * sy));

	mat[0][1] =  sz;

	mat[0][2] = ((cz * sy) + (sz * sx * cy));

	mat[0][3] = 0;

	mat[1][0] = -1*(sz + (cz * sx * sy));

	mat[1][1] = cz;

	mat[1][2] = ((-sz * sy) + (cz * sx * cy));

	mat[1][3] = 0;

	mat[2][0] = -1 * cx * sy ;

	mat[2][1] = -1*sx ;

	mat[2][2] = cx * cy ;

	mat[2][3] = 0;

	mat[3][0] = 0;//xtranslation;
	mat[3][1] = 0;//ytranslation;
	mat[3][2] = 0;//ztranslation;
	mat[3][3] = 1;

}
