#ifndef STRUCTS
	#include "structs.h"
#endif
#include "tilestuf.h"
#include "keys.h"

#define MAX_SPEED 8

extern char volatile Keyboard[128];
extern char volatile KeyScan;    // modified by keyboard interrupt handler

void DrawMe(struct Sprite me,
			int px,
			int py,
			struct Picture_Type **me_pics,
			uchar far *vscreen)
{
	DrawTransTile(me.x-px,me.y-py,
					 me_pics[me.frame],
					 vscreen);

}

void DoMe(struct Sprite *me,struct Picture_Type *map)
{
	const BIG_TILE_WIDTH 	= 	32	;
	const BIG_TILE_HEIGHT 	= 	32	;
	const BIG_TILE_SHIFT 	= 	5	;

	const NUM_ME_FRAMES	= 	16   ;

	//////////////// Walking crap ................
	//////// Left and right ......................
	if (me->dir==RIGHT) {
		if (*(map->Data+(((me->y+16) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+19+me->speed ) >> BIG_TILE_SHIFT )) > 3) {
			if (*(map->Data+(((me->y+31) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+19+me->speed ) >> BIG_TILE_SHIFT )) > 3) {
				me->x+=me->speed;

				me->frame++;
				if (me->frame==8 /* end of walk right frames */ ) {
					me->frame=2;
				}
			}
			else {       // No room to the right.
				me->dir=WAITING;
				me->frame=0;
				me->speed=0;
			}
		}
		else {       // No room to the right.
				me->dir=WAITING;
				me->frame=0;
				me->speed=0;
		}
	}

	if (me->dir==LEFT) {
		if (*(map->Data+(((me->y+16) >> BIG_TILE_SHIFT)*map->Width) + ((me->x + me->speed) >> BIG_TILE_SHIFT )) > 3) {
			if (*(map->Data+(((me->y+31) >> BIG_TILE_SHIFT)*map->Width) + ((me->x + me->speed) >> BIG_TILE_SHIFT )) > 3) {
				me->x+=me->speed;

				me->frame++;
				if (me->frame==15) {
					 me->frame=9;
				}
			} else {
				me->dir=WAITING;
				me->frame=0;
				me->speed=0;
			}
		}
		else {
				me->dir=WAITING;
				me->frame=0;
				me->speed=0;
			}
	}

	////////////// Jumping crap .............

	if ((me->status==WAITING)||
		(me->status==WALKING)) {
		if (*(map->Data+((((me->y+32) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+6) >> BIG_TILE_SHIFT))) > 3) {
			if (*(map->Data+((((me->y+32) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+19) >> BIG_TILE_SHIFT))) > 3) {
				me->status=LANDING;
				me->jump_inc=1;
				me->jump_counter=8;
			}
		}
	}


	// player has no "ground" underneath them
	if (me->status==LANDING) {
		if (*(map->Data+((((me->y+32) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+6) >> BIG_TILE_SHIFT))) > 3) {
			if (*(map->Data+((((me->y+32) >> BIG_TILE_SHIFT)*map->Width) + ((me->x+19) >> BIG_TILE_SHIFT))) > 3) {
				me->y+=me->jump_inc;
				me->jump_counter--;
				if (me->jump_counter==0) {
					if (me->jump_inc < 4) {
						me->jump_inc<<=1;
						me->jump_counter=4/me->jump_inc;
					}
					else {
						me->jump_inc=4;
						me->jump_counter=1;
					}
				}
			}
		}
		else {
			me->status=WAITING;
		}
	}

	// player is JUMPING ! ( going up )
	if (me->status==JUMPING) {
		if (((*(map->Data+((((me->y+16-me->jump_inc)>> BIG_TILE_SHIFT)*map->Width)+((me->x +6) >> BIG_TILE_SHIFT)))) > 3) &&
			((*(map->Data+((((me->y+16-me->jump_inc)>> BIG_TILE_SHIFT)*map->Width)+((me->x+19) >> BIG_TILE_SHIFT)))) > 3)) { //and can jump
			me->y-=me->jump_inc;
			me->jump_counter--;
			if (me->jump_counter==0) {
				me->jump_inc>>=1;
				if (me->jump_inc==0) {
					me->status=LANDING;
					me->jump_inc=1;
					me->jump_counter=8;
				} else {
					me->jump_counter=8/me->jump_inc;
				}
			}
		} else {
			me->status=LANDING;
			me->jump_inc=1;
			me->jump_counter=8;
		}
	}
}

void DoKeys(struct Sprite *me)
{
	if (Keyboard[RIGHT_ARROW_PRESSED]) {
		if (me->dir!=RIGHT) {
			me->dir=RIGHT;
			if (me->speed < 0) {
				me->speed+=2;
			}
			if (me->speed == 0 ) {
				me->speed=1;
			}
			me->frame=2;             // Start of the right frames
		}
		else if (me->speed < MAX_SPEED) {
			if (me->counter==10) {
				me->speed++;
				me->counter=0;
			} else {
				me->counter++;
			}
		}
	}
	else if (Keyboard[LEFT_ARROW_PRESSED]) {
		if (me->dir!=LEFT) {
			me->dir=LEFT;
			if (me->speed > 0) {
				me->speed-=2;
			}
			if (me->speed == 0 ) {
				me->speed=-1;
			}
			me->frame=9;             // Start of the left frames

		} else if (me->speed > -MAX_SPEED) {
			if (me->counter==10) {
				me->speed--;
				me->counter=0;
			} else {
				me->counter++;
			}
		}
	}
	else if (me->speed==0) {
//		me->status=WAITING;
		me->dir=WAITING;
		me->frame=0;
		me->counter=0;
		me->speed=0;
	}
	else if (me->speed > 0) {
		me->speed--;
	}
	else if (me->speed < 0) {
		me->speed++;
	}


	if (Keyboard[SPACE_PRESSED]) {
		if ((me->status!=JUMPING) && (me->status!=LANDING)) {
				me->status=JUMPING;
				me->jump_inc=4;
				me->jump_counter=16;
		}
	}
//      me->frame = ;
//		me->frame_inc=1;

/*
	if (Keyboard[DOWN_ARROW_PRESSED] ) {
		if ((me->status!=JUMPING) && (me->status!=LANDING)) {
			me->status=WAITING;
			me->dir=WAITING;
			me->frame=0;
			me->counter=0;
			me->speed=0;
		}
	} */
}