#include "keys.h"
#include "structs.h"

char volatile Keyboard[128] = {0};	// All keys UP
char volatile KeyScan;    // modified by keyboard interrupt handler
void interrupt (*OldInt9)(); // ptr to BIOS keyboard handler
void interrupt far (*OldInt12)(); // ptr to BIOS keyboard handler

//
//  This is the new int 9h handler.  This allows for smooth interactive
//  scrolling.  If the BIOS keyboard handler was not disabled holding
//  down one of the arrow keys would overflow the keyboard buffer and
//  cause a very annoying beep.
//

// If "KEYBOARD_IN_C" is "define"`d then the C funtion will be used
// otherwise the ASM version is used !!!
// KEYBOARD_IN_C is (or isn't) defined in MAD.H

#ifdef KEYBOARD_IN_C

//#undef outp(x,y)
//#undef inp(x)
void interrupt NewInt9(void) // __CPPARGS) //void
{
	  register char x;
	  KeyScan=inportb(0x60);       // read key code from keyboard
	  x=inportb(0x61);             // tell keyboard that key was processed
	  outportb(0x61,(x|0x80));
	  outportb(0x61,x);
//	  if(KeyScan==RIGHT_ARROW_REL||KeyScan==LEFT_ARROW_REL) KeyScan=0;// check for keys

	  if(KeyScan & 0x80)
	  {
		Keyboard[KeyScan&0x7F]=KEY_IS_UP;
	  }
	  else
	  {
		Keyboard[KeyScan]=KEY_IS_DOWN;
	  }
	// INL_KeyHook();
	  outportb(0x20,0x20);                  // send End-Of-Interrupt
}

#else

void interrupt NewInt9(void) // __CPPARGS) //void
{
	asm {
			mov		dx,0x60
			in		al,dx
			mov		cl,al
			mov		dx,0x61
			in		al,dx
			mov		di,ax
			or		al,0x80
			out		dx,al
			mov		ax,di
			out		dx,al

			cmp	    al,0
			jg		down_key
	}
	up_key:
	asm{
			//ads
	}
	down_key:
	asm{
			//asd
	}
			mov		KeyScan,cx
			mov		dx,0x20
			mov		al,0x20
			out		dx,al
}
#endif

char SerialBuff[100]={0};
char head=0,tail=0;

extern char oldbx,oldby,badx,bady;

void interrupt far NewInt12(void)
{
//	KeyScan=1;
//	puts("dsf");
//	printf("Serial\n");
	if(inportb(0x3FD)&1)
	{
		SerialBuff[head++]=inportb(0x3F8);
//		printf("\n%d",SerialBuff[head-1]);
		if (head==100) head=0;
	}
	outportb(0x20,0x20);
}

void RestoreSerial(void)
{
	_dos_setvect(12,OldInt12);
}

void InitSerial(void)
{
	char imr,i;
	OldInt12=_dos_getvect(12);
	_dos_setvect(12,NewInt12);

	imr=inportb(0x21);
	outportb(0x21,imr  & 0xEF);

	outportb(0x3F8+1,0x01);

	for(i=0;i<6;i++)
	inportb(0x3F8+i);

	/// GPO ???

}

//  This routine restores the original BIOS keyboard interrupt handler
//
	void RestoreKeyboard(void)
	{
	  _dos_setvect(KEYBOARD,OldInt9);   // restore BIOS keyboard interrupt
	}
//
//  This routine saves the original BIOS keyboard interrupt handler and
//  then installs a customer handler for this program.
//
	void InitKeyboard()
	{
	  OldInt9 =_dos_getvect(KEYBOARD);   // save BIOS keyboard interrupt
	  _dos_setvect(KEYBOARD,NewInt9);   // install new int 9h handler
	}
