#include<conio.h>
#include<dos.h>
//
//
	#define KEYBOARD 0x09
//
// Keyboard press/release codes for the INT 9h handler
//
	#define RIGHT_ARROW_PRESSED   77
	#define RIGHT_ARROW_REL      205
	#define LEFT_ARROW_PRESSED    75
	#define LEFT_ARROW_REL       203
	#define ESC_PRESSED          129
	#define UP_ARROW_PRESSED      72
	#define UP_ARROW_REL         200
	#define DOWN_ARROW_PRESSED    80
	#define DOWN_ARROW_REL       208
	#define SPACE_PRESSED		  32

//#ifdef __cplusplus
//extern "C" {
//#endif

	void _interrupt NewInt9(void);
	void RestoreKeyboard(void);
	void InitKeyboard(void);

//#ifdef __cplusplus
//  }
//#endif
//#ifdef __cplusplus
//	#define __CPPARGS ...
//#else
	#define __CPPARGS
//#endif

	int volatile KeyScan;    // modified by keyboard interrupt handler
	void _interrupt (*OldInt9)(); // ptr to BIOS keyboard handler

//
//  This is the new int 9h handler.  This allows for smooth interactive
//  scrolling.  If the BIOS keyboard handler was not disabled holding
//  down one of the arrow keys would overflow the keyboard buffer and
//  cause a very annoying beep.
//




#define	KEYBOARD_IN_C


#ifdef KEYBOARD_IN_C

void _interrupt NewInt9(void) // __CPPARGS) //void
{
	  register char x;
	  KeyScan=inp(0x60);       // read key code from keyboard
	  x=inp(0x61);             // tell keyboard that key was processed
	  outp(0x61,(x|0x80));
	  outp(0x61,x);
	  outp(0x20,0x20);                  // send End-Of-Interrupt
	  if(KeyScan==RIGHT_ARROW_REL||KeyScan==LEFT_ARROW_REL) KeyScan=0;// check for keys
}

#else

void _interrupt NewInt9(void) // __CPPARGS) //void
{
	asm {
			mov		dx,0x60
			in		al,dx
			mov		cx,ax
			mov		dx,0x61
			in		al,dx
			mov		di,ax
			or		al,0x80
			out		dx,al
			mov		ax,di
			out		dx,al
			mov		dx,0x20
			mov		al,0x20
			out		dx,al
			cmp		cx,RIGHT_ARROW_REL
			je		near_end
			cmp		cx,LEFT_ARROW_REL
			jne		the_end
	}
near_end:
	asm {
			mov		cx,0
	}
the_end:
	asm {
			mov		KeyScan,cx
	}
}
#endif


//  This routine restores the original BIOS keyboard interrupt handler
//
	void RestoreKeyboard(void)
	{
	  _dos_setvect(KEYBOARD,OldInt9);   // restore BIOS keyboard interrupt
	}
//
//  This routine saves the original BIOS keyboard interrupt handler and
//  then installs a customer handler for this program.
//
	void InitKeyboard()
	{
	  OldInt9 =_dos_getvect(KEYBOARD);   // save BIOS keyboard interrupt
	  _dos_setvect(KEYBOARD,NewInt9);   // install new int 9h handler
	}

//
