#include "tilestuf.h"

void DrawPieceOfTile(int screenx,
				int screeny,
				int tilex,
				int tiley,
				int amountx,
				int amounty,
				struct Picture_Type *pic,
				uchar far *vscreen)
{
	long screen_offset = (screeny << 8) + (screeny << 6) + screenx;
	int tile_offset = (tiley << 5 ) +tilex;
	int i,j;

	for ( j=0;j < amounty ; j++)
	{
		memcpy((vscreen+screen_offset),(pic->Data+tile_offset),amountx);

		tile_offset+=pic->Width;
		screen_offset+=SCREEN_WIDTH;

	}
}

void DrawFullTile(int screenx,
				  int screeny,
				  struct Picture_Type *pic,
				  uchar far *vscreen)
{
	long screen_offset = (screeny << 8) + (screeny << 6) + screenx;
	register int tile_offset=0,i;

	for ( i=0;i < pic->Height ; i++)
	{
		memcpy((vscreen+screen_offset),(pic->Data+tile_offset),pic->Width);
		tile_offset+=pic->Width;
		screen_offset+=SCREEN_WIDTH;
	}
}
void DrawTransTile(int screenx,
				  int screeny,
				  struct Picture_Type *pic,
				  uchar far *vscreen)
{
	long screen_offset = (screeny << 8) + (screeny << 6) + screenx;
	register int tile_offset=0,i,j;

	for ( i=0;i < pic->Height ; i++)
	{
		for (j=0;j<pic->Width;j++) {
			if (*(pic->Data+tile_offset)) {
				*(vscreen+screen_offset)=*(pic->Data+tile_offset);
			}
			screen_offset++;
			tile_offset++;
		}
		screen_offset+=SCREEN_WIDTH-pic->Width;
	}
}

void FreeTiles(struct Picture_Type **tiles,int num)
{
	int i;
	for (i=0;i<num;i++) {
		FreePic(tiles[i]);
	}
}
